unit Timer;

          {ͻ}
          {                                                        }
          {  unit Timer                                            }
          {                                                        }
          {  jednotka pro odmerovani casovych intervalu            }
          {                                                        }
          {  (C)1993 SofCon, Stresovicka 49, 160 00 Praha 6        }
          {          Ing. Vladimir Kastner, Na Vlcovce 6, Praha 6  }
          {  (C)1998 SofCon, Jan Hvozdovic                         }
          {                                                        }
          {ͼ}


{!Ka !!! jednotka je vytvorena jen pro zpetnou kompatibilitu }
{    !!! v novych knihovnach nepouzivat                      }
{        nejsou definovany vsechny puvodni metody            }
interface

uses
  SyncObjs;

const
  cName     = 'Timer';
  cVer      = 'v3.0, 11.11.1999';

type
  tTimer = class(TObject)
    constructor Init;
    destructor Done; virtual;
    procedure SaveTime;
    function  TstTime (Ms:LongInt):Boolean;  {!Ka !!! zmena - po SaveTime ceka Ms milisekund }
                { Test, zda uplynulo Ms milisekund }
(*
    function  ReadTime   :LongInt;
                { Vraci kolik ms uplynulo od nastaveni }
    procedure SetCount(Ms:LongInt);
                { Zaznamena jak dlouho se ma cekat }
    function  TstCount   :Boolean;
                { Vraci true, pokud zadany cas jiz ubehl }
    function  ReadCount  :LongInt;
                { Vraci kolik ms zbyva do vyprseni nastaveneho casu }
*)
   private
    TM_FlSave     : Boolean;
    TM_TimerEvent : TEvent;   { odmerovani casovych intervalu }
(*
    TM_vTime      : Longint;
    TM_aTime      : Longint;
    TM_cTime      : Longint;
*)
    procedure CreateTimerEvent;
  end;

implementation

const
  TimerCnt : Integer = 0;

procedure tTimer.CreateTimerEvent;
var
  s : String;
begin
  if not Assigned(TM_TimerEvent) then
  begin
    Inc(TimerCnt);
    Str(TimerCnt,s);
    TM_TimerEvent:=TEvent.Create(nil{@SecurityAttributes1},False{True},True,'TMEvent'+s);
  end;
end;

constructor tTimer.Init;
begin
  Create;
  CreateTimerEvent;
  TM_TimerEvent:=nil;
  TM_FlSave:=True;
end;

destructor tTimer.Done;
begin
  if Assigned(TM_TimerEvent) then
  begin
    TM_TimerEvent.Free;
    TM_TimerEvent:=nil;
  end;
  inherited;
end;

procedure tTimer.SaveTime;
  { zaznamena hodnotu aktualniho casu }
begin
  CreateTimerEvent;
  TM_FlSave:=True;
end;

function tTimer.TstTime(Ms: LongInt):Boolean;
  {test, zda uplynulo Ms milisekund}
begin
  CreateTimerEvent;
  if TM_FlSave then
  begin
    TM_FlSave:=False;
    TM_TimerEvent.WaitFor(Ms);
  end;
  TstTime:=True;
end;

end.
